//+------------------------------------------------------------------+
//|                                             enha_MarketNoise.mq4 |
//|              Copyright  2008,2009,2010 enha Consulting, Germany |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, 2009 enha Consulting, Germany"
#property link      "mailto:enhaConsulting@mbn-web.de"


#include <stdlib.mqh>
//#include <incl_enha_Global.mq4>

#define        Name        "MarketNoiseSound"

#define        RV_Init        +999999
#define        RV_Success     +1
#define        RV_Error       -1
#define        RV_PrioBreak   -2
#define        RV_TimeOut     -3
#define        RV_Stop        -999999

#define        sSwitchPrefix        "enha_Switch_"
#define        sGloVarPrefix        "enha_GVar_"
#define        sTradeParPrefix      "enha_TradePar_"
#define        sSysParPrefix        "enha_SysPar_"
#define        sOperatingModePrefix "enha_OM_"
#define        sdboLedValPrefix     "dbo_val_"
#define        sdboLedLblPrefix     "dbo_lbl_"

extern int     debug=0;
extern string  dFormatter="--";           // This string is used for formatting the debug output
string         Tab="";                    // The formatter itself for generating a FCT-call-level-based 
                                          // structured output
#define        fctStart 0
#define        fctEnd   1

extern int  iSoundOn=1;  
extern int  iTicksPerSound=1;
extern int  iMainPrices=5;
extern int  iMSecsBetweenTicksNormal=100;
extern int  iMSecsBetweenTicksFast=70;
extern int  iMSecsBetweenTicksExplosion=50;
extern int  iPipsPerRunNormal=1;
extern int  iPipsPerRunFast=3;
extern int  iPipsPerRunExplosion=20;

extern string  sSndTickUpStandard="enha_Snd_TickUp.wav";
extern string  sSndTickDnStandard="enha_Snd_TickDn.wav";
extern string  sSndTickUpMainPrice="enha_Snd_TickUpMain.wav";
extern string  sSndTickDnMainPrice="enha_Snd_TickDnMain.wav";

double   dLastTickPrice=0;
double   dLastTickVolume=0;


//-----------------------------------------------------------------------------
//----   FUNCTION: init() - START
//-----------------------------------------------------------------------------
/*
   Description:
         - 
      
   Parameters:
      - 
   
   Creation Date: 2010-02-03 NH
   
   Last Change:   
      2010-02-03 NH Version 1.0.0
         - Design, implementation and testing
*/      
int init()
  {
   int      RetValue=RV_Success;
   string   sFctName="init()";
   string   Version="1.0.0";

   int      suxs=0;
   int      LastError=0;

   bool     bToggleSwitch=true;
   string   sGlobalVarName="";

   Tab=debugFormatter(fctStart,Tab);
   if (debug>0) Print(Tab,"FCT ",sFctName,"V",Version," MOD EntryPoint");

   sGlobalVarName=StringConcatenate(sSwitchPrefix,Name);   

   if (GlobalVariableCheck(sGlobalVarName)) {
      iSoundOn=NormalizeDouble(GlobalVariableGet(sGlobalVarName),0);
   }
   else suxs=GlobalVariableSet(sGlobalVarName,iSoundOn);


   LastError=GetLastError();
   if (LastError!=0) Print(Tab,"FCT ",sFctName," - ERROR(",LastError,"): ",ErrorDescription(LastError));

   if (debug>0) Print(Tab,"FCT ",sFctName,"V",Version," MOD ExitPoint - iRetValue: ",RetValue);
   Tab=debugFormatter(fctEnd,Tab);
   return(RetValue);

  }
//----   FUNCTION: init() - END

  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int      iRetValue=-1;
   string   sFctName="start()";
   string   Version="1.0.0";

   int      LastError=0;
   int      suxs=0;

   double   dPriceDelta=0;
   double   dLastBid=0;
   int      iDeltaPips=0;
   double   dVolumeDelta=0;            
   int      i=0;
   string   sSndTickMainPrice="";
   string   sSndTickStandard="";
   double   dTickPrice=0;
   bool     bExitLoop=false;
   string   sGlobalVarName="";

   
   if (debug>0) Tab=debugFormatter(fctStart,Tab);
   if (debug>0) Print(Tab,"FCT ",sFctName,"V",Version," MOD EntryPoint");
   
   sGlobalVarName=StringConcatenate(sSwitchPrefix,Name);   
   if (GlobalVariableCheck(sGlobalVarName)) {
      iSoundOn=NormalizeDouble(GlobalVariableGet(sGlobalVarName),0);
   }


   if (iSoundOn==1)
   {
      if (dLastTickPrice==0) dLastTickPrice=Close[0];

      dLastBid=Bid;
      dPriceDelta=NormalizeDouble((dLastBid-dLastTickPrice)/Point,0);
      iDeltaPips=MathAbs(dPriceDelta);
      //dTickPrice=dLastTickPrice;
      
      if (debug>0) Print(Tab,"FCT ",sFctName," - Bid,dLastBid,dLastTickPrice,dPriceDelta,iDeltaPips: ",Bid,", ",dLastBid,", ",dLastTickPrice,", ",dPriceDelta,", ",iDeltaPips);

      while(!bExitLoop)
      {
         for (i=1; i<=iDeltaPips; i++)
         {
            if (dPriceDelta>0)
            {
               dTickPrice=(dLastTickPrice+i*Point)/Point;
               if (debug>0) Print(Tab,"FCT ",sFctName,".While.For.dPriceDelta>0 - i,dTickPrice: ",i,", ",dTickPrice);
               sSndTickMainPrice=sSndTickUpMainPrice;
               sSndTickStandard=sSndTickUpStandard;
            }   
            if (dPriceDelta<0)
            {
               dTickPrice=(dLastTickPrice-i*Point)/Point;
               if (debug>0) Print(Tab,"FCT ",sFctName,".While.For.dPriceDelta<0 - i,dTickPrice: ",i,", ",dTickPrice);
               sSndTickMainPrice=sSndTickDnMainPrice;
               sSndTickStandard=sSndTickDnStandard;
            }   
         
            Comment(dTickPrice,", ",MathMod(dTickPrice,iMainPrices),", ",MathMod(dTickPrice,iTicksPerSound));
            if (debug>0) Print(Tab,"FCT ",sFctName,".While.For - dTickPrice,i,MathModMain,MathModStandard,iDeltaPips: ",dTickPrice,", ",i,", ",MathMod(dTickPrice,iMainPrices),", ",MathMod(dTickPrice,iTicksPerSound),", ",iDeltaPips);
            
            if (NormalizeDouble(MathMod(dTickPrice,iMainPrices),0)==0) {
               if (debug>0) Print(Tab,"FCT ",sFctName,".While.For.SndTickMain - i,dTickPrice,iMainPrices: ",i,", ",dTickPrice,", ",iMainPrices);
               PlaySound(sSndTickMainPrice);
               Sleep(20);
            }   
            //else if (NormalizeDouble(MathMod(dTickPrice,iTicksPerSound),0)==0) {
            else {
               if (debug>0) Print(Tab,"FCT ",sFctName,".While.For.SndTickStandard - i,dTickPrice,iTicksPerSound: ",i,", ",dTickPrice,", ",iTicksPerSound);
               PlaySound(sSndTickStandard);
            }   
            
            if (iDeltaPips<=iPipsPerRunNormal)        Sleep(iMSecsBetweenTicksNormal);
            else if (iDeltaPips<iPipsPerRunFast)      Sleep(iMSecsBetweenTicksFast);
            else if (iDeltaPips<iPipsPerRunExplosion) Sleep(iMSecsBetweenTicksExplosion);
         }
      
         RefreshRates();
         if (Bid==dLastBid) bExitLoop=true;
         else
         {
            dLastTickPrice=dLastBid;
            dLastBid=Bid;
            dPriceDelta=NormalizeDouble((dLastBid-dLastTickPrice)/Point,0);
            iDeltaPips=MathAbs(dPriceDelta);
         }
      }      
      dLastTickPrice=Bid;
      dLastTickVolume=iVolume(Symbol(),PERIOD_W1,0);
   }

   LastError=GetLastError();
   if (LastError!=0) Print(Tab,"FCT ",sFctName," - ERROR(",LastError,"): ",ErrorDescription(LastError));
   if (debug>0) Print(Tab,"FCT ",sFctName,"V",Version," MOD ExitPoint - iRetValue: ",iRetValue);
   if (debug>0) Tab=debugFormatter(fctEnd,Tab);
   return(iRetValue);

  }
//+------------------------------------------------------------------+


//-----------------------------------------------------------------------------
//----   FUNCTION: debugFormatter() - START
//-----------------------------------------------------------------------------
/*
   Description:
         - 
      
   Parameters:
      - 
   
   Creation Date: 2010-02-03 NH
   
   Last Change:   
      2010-02-03 NH Version 1.0.0
         - Design, implementation and testing
*/      

string debugFormatter (int iMode, string sTab)
{
   string   sFctName="debugFormatter()";
   string   Version="1.0.0";

   if       (iMode==0)  sTab=StringConcatenate(sTab,dFormatter);
   else if  (iMode==1)  sTab=StringSubstr(sTab,StringLen(dFormatter));

   return(sTab);
}
//----   FUNCTION: debugFormatter() - END

