//+------------------------------------------------------------------+
//|                                      enha_TSwitchCloseAllBEL.mq4 |
//|           Copyright  2008,2009,2010 by enha Consulting, Germany |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,2009,2010 by enha Consulting, Germany"
#property link      "mailto:enhaConsulting@mbn-web.de"


#include <stdlib.mqh>
#include <incl_enha_Global.mq4>
#include <lib_enha_dbo.mq4>

#define        Name        "MarketNoiseSound"


//-----------------------------------------------------------------------------
//----   FUNCTION: start() - START
//-----------------------------------------------------------------------------
/*
   Description: 
      
      
   Parameters:
      - 
      
   Creation Date: 2010-02-03 NH
   
   Last Change:   
      2010-02-03 NH Version 1.0.0
         - Design, implementation and testing
*/
int start()
  {
   int      RetValue=RV_Error;
   string   sFctName="start()";
   string   Version="1.0.0";

   int suxs=0;
   int LastError=0;

   bool     bToggleSwitch=true;
   string   sGlobalVarName="";
   
   Tab=debugFormatter(fctStart,Tab);
   if (debug>0) Print(Tab,"FCT ",sFctName,"V",Version," MOD EntryPoint");

   PlaySound(Snd_KeyPressed);
   WindowRedraw();

   sGlobalVarName=StringConcatenate(sSwitchPrefix,Name);   

   if (GlobalVariableCheck(sGlobalVarName)) {
      bToggleSwitch=NormalizeDouble(GlobalVariableGet(sGlobalVarName),0);
      bToggleSwitch=!bToggleSwitch;
   }

   suxs=GlobalVariableSet(sGlobalVarName,bToggleSwitch);

   if (suxs<=RV_Error) {
      dbo_MessageDisplay(sGlobalVarName + " could not be set!!!");
      PlaySound(Snd_ScriptFailed);
   }   
   else {
      RetValue=RV_Success;
   }   

   if (GlobalVariableCheck("enha_SysPar_TradeManHwnd"))
   {
      int iHwnd=NormalizeDouble(GlobalVariableGet("enha_SysPar_TradeManHwnd"),0);
      if (iHwnd>0) KickOffEAonWnd(iHwnd);
   }
   
   suxs=dbo_LedUpdate("dbo_val_ScriptContext",cReady);

   LastError=GetLastError();
   if (LastError!=0) Print(Tab,"FCT ",sFctName," - ERROR(",LastError,"): ",ErrorDescription(LastError));

   if (debug>0) Print(Tab,"FCT ",sFctName,"V",Version," MOD ExitPoint - iRetValue: ",RetValue);
   Tab=debugFormatter(fctEnd,Tab);
   return(RetValue);
  }
//+------------------------------------------------------------------+